from dataclasses import dataclass

""""
Unlike YaML template file, this is used to encapsule mutable data during runtime.
Meanwhile, the YaML file is intended to be used to generate the cfg file to be pasted to the device
"""


@dataclass
class AbeewaySmartBadgeConfig:  # <- Firmware version 2.4-1 only
    # TODO add a way to choose which version on the class constructor
    # [param, value]
    ul_period: [int, int] = (0, 300)
    lora_period: [int, int] = (1, 600)
    pw_stat_period: [int, int] = (2, 0)
    periodic_pos_period: [int, int] = (3, 0)
    unknown: [int, int] = (4, 0)
    geoloc_sensor: [int, int] = (5, 1)
    geoloc_method: [int, int] = (6, 1)
    antenna: [int, int] = (7, 0)
    motion_nb_pos: [int, int] = (8, 1)
    gps_timeout: [int, int] = (9, 240)
    agps_timeout: [int, int] = (10, 45)
    gps_ehpe: [int, int] = (11, 20)
    gps_convergence: [int, int] = (12, 30)
    config_flags: [int, int] = (13, 213055)
    transmit_strat: [int, int] = (14, 2)
    ble_beacon_cnt: [int, int] = (15, 4)
    ble_beacon_timeout: [int, int] = (16, 2)
    gps_standby_timeout: [int, int] = (17, 0)
    confirmed_ul_bitmap: [int, int] = (18, 0)
    confirmed_ul_retry: [int, int] = (19, 3)
    motion_sensitivity: [int, int] = (20, 131073)
    shock_detection: [int, int] = (21, 0)
    periodic_activity_period: [int, int] = (22, 0)
    motion_duration: [int, int] = (23, 180)
    geofencing_scan_period: [int, int] = (24, 0)
    geofencing_collect_period: [int, int] = (25, 60)
    ble_rssi_filter: [int, int] = (26, -85)
    temperature_high: [int, int] = (27, 255)
    temperature_low: [int, int] = (28, 255)
    temperature_action: [int, int] = (29, 0)
    transmit_strat_custom: [int, int] = (30, 0)
    network_timeout_check: [int, int] = (31, 432000)
    network_timeout_reset: [int, int] = (32, 172800)
    collection_scan_type: [int, int] = (33, 0)
    collection_nb_entry: [int, int] = (34, 20)
    collection_ble_filter_type: [int, int] = (35, 0)
    collection_ble_filter_main_1: [int, int] = (36, 0)
    collection_ble_filter_main_2: [int, int] = (37, 0)
    collection_ble_filter_sec_value: [int, int] = (38, 0)
    collection_ble_filter_sec_mask: [int, int] = (39, 0)
    battery_capacity: [int, int] = (40, -1)
    reed_switch_configuration: [int, int] = (41, 0)
    gnss_constellation: [int, int] = (42, 4)
    position_ble_filter_type: [int, int] = (77, 0)
    position_ble_filter_main_1: [int, int] = (78, 0)
    position_ble_filter_main_2: [int, int] = (79, 0)
    position_ble_filter_sec_value: [int, int] = (80, 0)
    position_ble_filter_sec_mask: [int, int] = (81, 0)
    position_ble_report_type: [int, int] = (82, 0)
    buzzer_volume: [int, int] = (83, 10)
    angle_detect_mode: [int, int] = (84, 0)
    angle_ref_acq: [int, int] = (85, 2)
    angle_ref_acc_x: [int, int] = (86, 0)
    angle_ref_acc_y: [int, int] = (87, 0)
    angle_ref_acc_z: [int, int] = (88, 0)
    angle_critical: [int, int] = (89, 30)
    angle_critical_hyst: [int, int] = (90, 5)
    angle_report_mode: [int, int] = (91, 1)
    angle_report_period: [int, int] = (92, 300)
    angle_report_repeat: [int, int] = (93, 0)
    angle_rising_time: [int, int] = (94, 5)
    angle_falling_time: [int, int] = (95, 5)
    angle_learning_time: [int, int] = (96, 5)
    angle_acc_accuracy: [int, int] = (97, 100)
    angle_deviation_delta: [int, int] = (98, 0)
    angle_deviation_min_interval: [int, int] = (99, 10)
    angle_deviation_max_interval: [int, int] = (100, 0)
    default_profile: [int, int] = (101, 0)
    password: [int, int] = (102, 123)
    gps_t0_timeout: [int, int] = (103, 30)
    gps_fix_timeout: [int, int] = (104, 0)
    geofencing_scan_duration: [int, int] = (105, 370)
    beaconing_type: [int, int] = (106, 0)
    beaconing_tx_power: [int, int] = (107, 2)
    beaconing_static_interval: [int, int] = (108, 10000)
    beaconing_motion_interval: [int, int] = (109, 333)
    beaconing_motion_duration: [int, int] = (110, 20)
    ble_cnx_adv_duration: [int, int] = (111, 600)
    beacon_id_0: [int, int] = (112, 0)
    beacon_id_1: [int, int] = (113, 0)
    beacon_id_2: [int, int] = (114, 0)
    beacon_id_3: [int, int] = (115, 0)
    beacon_id_4: [int, int] = (116, 0)
    sos_period: [int, int] = (117, 120)
    motion_debounce: [int, int] = (118, 1)
    button_mapping: [int, int] = (119, 74768)
    default_datarate: [int, int] = (120, -1)
    gps_ehpe_motion: [int, int] = (121, 40)
    gps_convergence_motion: [int, int] = (122, 20)
    gps_t0_timeout_motion: [int, int] = (123, 30)
    ble_cli_active: [int, int] = (245, 0)
    profile: [int, int] = (246, 0)
    consumption: [int, int] = (247, 0)
    ble_bond_info: [int, int] = (248, 1)
    mode: [int, int] = (249, 0)


# wip
class AbeewaySmartBadgeConfig2:
    def __init__(self, param, name, value):
        self.param = param
        self.name = name
        self.value = value
